function [mllogbs, sdrel] = mlbs(loglikq,loglikmc,priorq,priormc,qq,qmc,MMCit0);

% 1d. berechnen der IS - modellikelihood
loglikq=loglikq(MMCit0+1:end);
loglikmc=loglikmc(MMCit0+1:end);
priorq=priorq(MMCit0+1:end);
priormc=priormc(MMCit0+1:end);
qq=qq(MMCit0+1:end);
qmc=qmc(MMCit0+1:end);

L=size(loglikq,1);
M=L;
ratio = loglikq+priorq-qq;
ratiomax=max(ratio);
ratioexp=exp(ratio-ratiomax);

mllogmi = ratiomax+log(mean(ratioexp)); 
mlsdmi = (L)^(-.5)*exp(log(std(ratioexp))-log(mean(ratioexp)));

sdrel(1)= mlsdmi;


% 2b. Berechnen der RIS- modelliekihood


r=qmc-loglikmc-priormc;
[ls is]=sort(r);
logc=-r(is(end));

rqp=exp(max(r-max(r),-1e15))';
mllogri = -max(r)-log(mean(rqp));

[omega ac eib abserrn eff] = autocov(rqp,1000);
mlsdri = (abserrn(1,1))^.5/mean(rqp);
sdrel(2)=mlsdri;

% 3. iterative bridge  sampling, starting from ri and mi

maxit=20;
mllogbs=zeros(maxit,2);
mllogbs(1,1)=mllogmi;  
mllogbs(1,2)=mllogri;  

for i=2:maxit 
   %i
   logpostmc=loglikmc+priormc-mllogbs(i-1,2);
   logpostq=loglikq+priorq-mllogbs(i-1,2);
    maxqmc=max([qq logpostq],[],2);
   rq=logpostq-maxqmc-log(exp(log(M)+logpostq-maxqmc)+exp(log(L)+qq-maxqmc));
   maxqmc=max([qmc logpostmc],[],2);
   rmc=qmc-maxqmc-log(exp(log(M)+logpostmc-maxqmc)+exp(log(L)+qmc-maxqmc));
   %mllogbs(i,2)=mllogbs(i-1,2)+log(mean(rq)/mean(rmc));
   mllogbs(i,2)=mllogbs(i-1,2)+max(rq)+log(mean(exp(max(rq-max(rq),-1e15))))-max(rmc)-log(mean(exp(max(rmc-max(rmc),-1e15))));

   
   logpostmc=loglikmc+priormc-mllogbs(i-1,1);
   logpostq=loglikq+priorq-mllogbs(i-1,1);
   maxqmc=max([qq logpostq],[],2);
   rq=logpostq-maxqmc-log(exp(log(M)+logpostq-maxqmc)+exp(log(L)+qq-maxqmc));
   maxqmc=max([qmc logpostmc],[],2);
   rmc=qmc-maxqmc-log(exp(log(M)+logpostmc-maxqmc)+exp(log(L)+qmc-maxqmc));
   mllogbs(i,1)=mllogbs(i-1,1)+max(rq)+log(mean(exp(max(rq-max(rq),-1e15))))-max(rmc)-log(mean(exp(max(rmc-max(rmc),-1e15))));
   
end   
rmc=exp(max(rmc-max(rmc),-1e15));
rq=exp(max(rq-max(rq),-1e15));

[omega ac eib abserrn eff] = autocov(rmc',1000);
mlsdbs =(abserrn(1,1)/(mean(rmc)^2)+((std(rq)/mean(rq))^2)/L)^.5;
sdrel(3)=mlsdbs;

