function [loglikq,loglikmc,priorq,priormc,qq,qmc] = mlbs_ql(y,x,e0,prsig,prbem,prbeinf,mumcmc,betaymcmc,betammcmc,sigmcmc,etamcmc,etapost,betapostm,betapostchol,igpost,loglikmc,it0,L);

% bridge sampling estimators: random permuations  from MCMC sample of size MMC 

n=size(y,1);
ylag=size(betaymcmc,1);
mlag=size(betammcmc,1);
mnst=size(betammcmc,2);
lags=max([ylag,mlag]);
index=[];for i=1:lags;index=[index;lags-i+1:n-i];end;index=index';
Z=[ones(n-lags,1) y(index(:,1:min([lags,ylag]))) x(index(:,1:min([lags,mlag])))];
y=y(lags+1:end);

it=size(etamcmc,3); %  length of the MCMC output
%if L < it-it0
if L < it
   % random selection of the MCMC output
u = simuni(it-it0,L);
betaymcmc=betaymcmc(:,u);
betammcmc=betammcmc(:,:,u);
etamcmc=etamcmc(:,:,u);
mumcmc=mumcmc(:,u);
sigmcmc=sigmcmc(:,u);
loglikmc=loglikmc(u);
end
betamcmc=[mumcmc;betaymcmc];
betamcmc=[betamcmc;reshape(betammcmc,mlag*mnst,L)];
betasize=size(betamcmc,1);

M=L;      % length of the q-sample
MMC=size(etapost,3);  % length of the mixture q

nst = size(etamcmc,1);
etasim = zeros(nst,nst,L);
betaysim = zeros(ylag,L);
betamsim=zeros(mlag,mnst,L);
musim=zeros(nst,L);
betasim=zeros(nst+ylag+mlag*mnst,L);
sigsize=size(sigmcmc,1);
sigsim=zeros(sigsize,L);

pini=ones(nst,1)/nst;

% 1b. simulate from q 

'1.a: simulate q'


mu = simuni(MMC,L);  

for m=1:MMC
   %   '1.a'
   %m
   index=mu==m;
   lm = sum(mu==m);
   if lm>0  %no simulation if m-th component is not selected
      betasim(:,mu==m) = squeeze(betapostm(:,ones(1,lm)*m)) + squeeze(betapostchol(:,:,m))*randn(betasize,lm);
      for ic=1:sigsize;
         sigsim(ic,mu==m) = (gamrnd(squeeze(igpost(ic,1,m)),squeeze(1./igpost(ic,2,m)))).^(-1);
      end
   end
      
end   
musim=betasim(1:nst,:);
betaysim=betasim(nst+1:nst+ylag,:);
betamsim=reshape(betasim(nst+ylag+1:end,:),mlag,mnst,L);


for ic=1:nst
   gam = gamrnd(squeeze(etapost(ic,:,mu)),ones(nst,L));   
   sumgam =  sum(gam,1);
   etasim(ic,:,:) =  gam./ sumgam(ones(1,nst),:);
end


loglikq=zeros(L,1);
%loglikmc=zeros(L,1);
priorq=zeros(L,1);
priormc=zeros(L,1);


for m=1:L
 %  m
 % evaluate likelihood 
 %
 if sigsize>1;
    [fv loglikq(m)] = filtvert(y,Z,squeeze(etasim(:,:,m)),pini,musim(:,m),betaysim(:,m),betamsim(:,:,m),sigsim(:,m));
 elseif mnst>1;
    [fv loglikq(m)] = filtvert2(y,Z,squeeze(etasim(:,:,m)),pini,musim(:,m),betaysim(:,m),betamsim(:,:,m),sigsim(:,m));
 elseif mnst==1;
    [fv loglikq(m)] = filtvert3(y,Z,squeeze(etasim(:,:,m)),pini,musim(:,m),betaysim(:,m),betamsim(:,:,m),sigsim(:,m));
 end
 
  
  
  %evaluate prior
  
  priorq(m) = prodinvgamlog(sigsim(:,m),prsig)+dirichlog(etasim(:,:,m),e0)+pmultnormlog(betasim(:,m),prbem,prbeinf);
  priormc(m) = prodinvgamlog(sigmcmc(:,m),prsig)+dirichlog(etamcmc(:,:,m),e0)+pmultnormlog(betamcmc(:,m),prbem,prbeinf);
  
 %%%%%%
 
   end   
   
   [qq,qmc] = evalq(betasim,etasim,sigsim,betamcmc,etamcmc,sigmcmc,etapost,betapostm,betapostchol,igpost);

